
//var langs_with_pos =["da","de","en","nl","pt"];
var langs_with_pos =["en","de","pt","da","nl", "sv"];
var langs_without_pos =["af","ar","bg","bn","cs","el","es","et","fa","fi","fr","he","hi","hr","hu","id","it","ja","kn","ko","lt","lv","mk","ml","mr","ne","no","pa","pl","ro","ru","sk","sl","so","sq","sv","sw","ta","te","th","tl","tr","uk","ur","vi","zh-cn","zh-tw"];

var num_rows = 20;

function lang_pos_toggle(event) {
    var $this =$(this);
    var checked_state = $this.prop("checked");

    var id = $this.attr("id");
    var split_id = id.split("-");
    var related_id = split_id[0] + "-pos-choice";

    //console.log("checked state = " + checked_state);

    var disable_state = !checked_state;
    $('#'+related_id + " *").prop('disabled',disable_state);
};

function ajax_error(jqXHR, textStatus, errorThrown) {
    alert('An error occurred... Look at the console (F12 or Ctrl+Shift+I, Console tab) for more information!');

    console.log('jqXHR:' + jqXHR);
    console.log('textStatus:' + textStatus);
    console.log('errorThrown:' + errorThrown);
}		


function add_titles(json_data) {
    $.each( json_data, function( htid_with_prefix, htid_val ) {
	var htid = htid_with_prefix.replace(/^htid:/,"");
	
	$.each(htid_val.records, function( internalid, metadata ) {
	    var title = metadata.titles[0];
	    $("[name='"+htid+"']").each(function() {$(this).html(title)});
	    console.log(htid + ", title = " + metadata.titles[0]);
	});
    });
}

function show_new_results(delta)
{
    $('.search-in-progress').css("cursor","wait");
    
    store_search_args.start += delta;
        
    $.ajax({
	type: 'GET',
	url: store_search_action,
	data: store_search_args,
	dataType: 'json',
	success: show_results,
	error: ajax_error
    });
}

function stream_generate_item(line,id,title)
{
    var css_class = (line%2 == 0) ? 'class="evenline"' : 'class="oddline"';
    
    var html_item = "";


    var babel_url = "https://babel.hathitrust.org/cgi/pt?id="+id+";view=1up;seq="+0;

    html_item += '<p ' + css_class + '>';
    //html_item += ' <span style="font-style: italic;" name="'+id+'"></span><br>';
    html_item += '<a target="_blank" href="' + babel_url + '">' + id + ': ' + title + '</a>';
    html_item += '</p>';

    return html_item;
}


function generate_item(line,id,id_pages)
{
    var css_class = (line%2 == 0) ? 'class="evenline"' : 'class="oddline"';
    
    var html_item = "";

    var id_pages_len = id_pages.length;
    
    for (var pi=0; pi<id_pages_len; pi++) {
	var page = id_pages[pi];
	
	var seqnum = page - 1;
	var babel_url = "https://babel.hathitrust.org/cgi/pt?id="+id+";view=1up;seq="+seqnum;

	if (id_pages_len>1) {

	    if (pi==0) {
		html_item += '<p ' + css_class + '>';
		html_item += '<span style="font-style: italic;" name="'+id+'"><span style="cursor: progress;">Loading ...</span></span><br>';

		
		html_item += id + ': <a target="_blank" href="' + babel_url + '">page ' + page + '</a> ';
	    }
	    else {
		html_item += ', <a target="_blank" href="' + babel_url + '">page ' + page + '</a> ';
		
		//var result_item = '<a target="_blank" href="' + babel_url + '">' + id + ', page ' + page + '</a>';
		//result_item += ' <span style="font-style: italic;" name="'+id+'"><span style="cursor: progress;">Loading ...</span></span>';
		//html_item += '<p ' + css_class + '>'+result_item+'</p>';
	    }
	}
	else {
	    html_item += '<p ' + css_class + '>';
	    html_item += ' <span style="font-style: italic;" name="'+id+'"><span style="cursor: progress;">Loading ...</span></span><br>';
	    html_item += '<a target="_blank" href="' + babel_url + '">' + id + ', page ' + page + '</a>';
	    html_item += '</p>';
	}
	
    }

    if (id_pages_len>1) {
	html_item += "</p>";
    }

    return html_item;
}

function stream_show_results(jsonData) {
    var docs = jsonData["result-set"].docs;
    var num_docs = docs.length -1;

    $('.search-in-progress').css("cursor","auto");
    
    var $search_results = $('#search-results');

    if (num_docs>0) {
	$search_results.html("<p>Results: " + num_docs + " volumes matched</p>");
	/*
	var from = parseInt(store_search_args.start);
	var to = from + num_rows;
	$search_results.append("<p>Showing matches: "+from+"-" + to + "</p>");
	*/
    }
    else {
	$search_results.html("<p>No volumes matched your query</p>");
    }

    for (var i=0; i<num_docs; i++) {
	var doc = docs[i];
	var id = doc.id;
	var title = doc.title_t;

	var html_item = stream_generate_item(i,id,title);
	$search_results.append(html_item);
    }
    return;
    // ****
    
    var htids = [];

    var prev_id = null;
    var prev_pages = [];
    
    var i=0;
    var line_num = 0;
    while (i<num_docs) {
//    for (var i=0; i<num_docs; i++) {
	var doc = docs[i];
	var id_and_page = doc.id.split(".page-");
	var id = id_and_page[0];
	var seqnum = parseInt(id_and_page[1]);
	var page = seqnum+1;

	if ((prev_id != null) && (id != prev_id)) {
	    // time to output previous item
	    var html_item = generate_item(line_num,prev_id,prev_pages);
	    $search_results.append(html_item);
	    line_num++;
	    prev_pages = [page];
	}
	else {
	    // accumulate pages
	    prev_pages.push(page)
	}
	
	htids.push("htid:"+id);

	prev_id = id;
	i++;
    }
    
    var html_item = generate_item(line_num,prev_id,prev_pages);
    $search_results.append(html_item);

    
    document.location.href="#search-results-anchor";
    
    var next_prev = '<p style="width:100%;"><div id="search-prev" style="float: left;"><a>&lt; Previous</a></div><div id="search-next" style="float: right;"><a>Next &gt;</a></div></p>';
    
    $search_results.append(next_prev);
    $('#search-prev').click(function(event) { show_new_results(-1*num_rows); });
    $('#search-next').click(function(event) { show_new_results(num_rows); });

    var search_start = store_search_args.start;
    if (search_start==0) {
	$('#search-prev').hide();
    }
    
    // Example URL for catalog metadata (multiple items)
    // http://catalog.hathitrust.org/api/volumes/brief/json/id:552;lccn:70628581|isbn:0030110408

    var htids_str = htids.join("|",htids);
    var cat_url = "http://catalog.hathitrust.org/api/volumes/brief/json/" + htids_str;
    	$.ajax({
	    url: cat_url,
	    dataType: 'jsonp',
	    jsonpCallback: "add_titles"
	});


    //var json_pretty = JSON.stringify(jsonData.response, null, '\t');
    //$('#search-results').text(json_pretty)
}


function show_results(jsonData) {
    var response = jsonData.response;
    var num_found = response.numFound;
    var docs = response.docs;
    var num_docs = docs.length;

    $('.search-in-progress').css("cursor","auto");
    
    var $search_results = $('#search-results');

    if (num_docs>0) {
	$search_results.html("<p>Results: " + num_found + " pages matched</p>");
	var from = parseInt(store_search_args.start);
	var to = from + num_rows;
	$search_results.append("<p>Showing matches: "+from+"-" + to + "</p>");
    }
    else {
	$search_results.html("<p>No pages matched your query</p>");
    }

    
    // https://babel.hathitrust.org/cgi/pt?id=hvd.hnnssu;view=1up;seq=11

    var htids = [];

    var prev_id = null;
    var prev_pages = [];
    
    var i=0;
    var line_num = 0;
    while (i<num_docs) {
//    for (var i=0; i<num_docs; i++) {
	var doc = docs[i];
	var id_and_page = doc.id.split(".page-");
	var id = id_and_page[0];
	var seqnum = parseInt(id_and_page[1]);
	var page = seqnum+1;

	if ((prev_id != null) && (id != prev_id)) {
	    // time to output previous item
	    var html_item = generate_item(line_num,prev_id,prev_pages);
	    $search_results.append(html_item);
	    line_num++;
	    prev_pages = [page];
	}
	else {
	    // accumulate pages
	    prev_pages.push(page)
	}
	
//	var css_class = (i%2 == 0) ? 'class="evenline"' : 'class="oddline"';
//	//var restful_safe_id = id.replace(/\./g,",").replace(/:/g, "+").replace(/\//g, "=");
	
//	var babel_url = "https://babel.hathitrust.org/cgi/pt?id="+id+";view=1up;seq="+seqnum;

//	var result_item = '<a target="_blank" href="' + babel_url + '">' + id + ', page ' + page + '</a>';
//	result_item += ' <span style="font-style: italic;" name="'+id+'"><span style="cursor: progress;">Loading ...</span></span>';
//	$search_results.append('<p ' + css_class + '>'+result_item+'</p>');

	htids.push("htid:"+id);

	prev_id = id;
	i++;
    }
    
    var html_item = generate_item(line_num,prev_id,prev_pages);
    $search_results.append(html_item);

    
    document.location.href="#search-results-anchor";
    
    var next_prev = '<p style="width:100%;"><div id="search-prev" style="float: left;"><a>&lt; Previous</a></div><div id="search-next" style="float: right;"><a>Next &gt;</a></div></p>';
    
    $search_results.append(next_prev);
    $('#search-prev').click(function(event) { show_new_results(-1*num_rows); });
    $('#search-next').click(function(event) { show_new_results(num_rows); });

    var search_start = store_search_args.start;
    if (search_start==0) {
	$('#search-prev').hide();
    }
    
    // Example URL for catalog metadata (multiple items)
    // http://catalog.hathitrust.org/api/volumes/brief/json/id:552;lccn:70628581|isbn:0030110408

    var htids_str = htids.join("|",htids);
    var cat_url = "http://catalog.hathitrust.org/api/volumes/brief/json/" + htids_str;
    	$.ajax({
	    url: cat_url,
	    dataType: 'jsonp',
	    jsonpCallback: "add_titles"
	});


    //var json_pretty = JSON.stringify(jsonData.response, null, '\t');
    //$('#search-results').text(json_pretty)
}

var store_search_args = null;
var store_search_action = null;

var group_by_vol_checked = 0;

function stream_submit_action(event)
{
    event.preventDefault();

    $('.search-in-progress').css("cursor","wait");

    var vq_text     = $('#vq').val();
    
    store_search_action = $('#search-form').attr("action");
    
    var arg_indent = $('#indent').attr('value');
    var arg_wt     = $('#wt').attr('value');
    var arg_start  = $('#start').attr('value');
    var arg_rows   = $('#rows').attr('value');
    var q_text     = $('#q').val();

    group_by_vol_checked = $('#group-results-by-id:checked').length;

    
    if ((q_text === "") && (vq_text === "")) {
	$('.search-in-progress').css("cursor","auto");
	alert("No query term entered");
	return;
    }

    var expr_all = "";
    var expr_md = "";
    var expr_tx = "";
    
    if (vq_text !== "") {
	// simplified case of issuing a volume-based metadata query
	//expr=search(col,q,fl,sort,rows)

    
	//var expr = "expr=search(";
	expr_md = "search(";
	expr_md += "htrc-full-ef20";
	expr_md += ",q=\""+vq_text+"\"";
	expr_md += ",fl=\"volumeid_s,id,title_t\"";
	expr_md += ",sort=\"id asc"+"\"";
	expr_md += ",indent=\""+arg_indent+"\"";
	expr_md += ",wt=\""+arg_wt+"\"";
	expr_md += ",start=\""+arg_start+"\"";
	expr_md += ",rows=\""+arg_rows+"\"";
	expr_md += ")";
	
	store_search_args = { q: vq_text, indent: arg_indent, wt: arg_wt,
			      start: arg_start, rows: arg_rows };
    }

    if (q_text !== "") {
	
	var fields = [];
	var universal_pos_tags = [ "VERB", "NOUN", "ADJ", "ADV", "ADP", "CONJ", "DET", "NUM", "PRT", "X" ];

	var arg_q = "";
	
	var split_q_text = q_text.split(/\s+/);
	for (var qi=0; qi<split_q_text.length; qi++) {
	    q_text = split_q_text[qi];
	    
	    for (var li=0; li<langs_with_pos.length; li++) {
		var lang = langs_with_pos[li];
		var lang_enabled_id = lang + "-enabled";
		var $lang_enabled_cb = $('#'+lang_enabled_id);
		if ($lang_enabled_cb.is(':checked')) {
		    console.log("Extracting POS tags for: " + lang);
		    
		    for (var ti=0; ti<universal_pos_tags.length; ti++) {
			var tag = universal_pos_tags[ti];
			var lang_tag_id = lang+"-"+tag+"-htrctoken-cb";
			var $lang_tag_cb = $('#'+lang_tag_id);
			if ($lang_tag_cb.is(':checked')) {
			    //var lang_tag_field = "xxxx"+lang+"_"+tag+"_htrctoken";
			    var lang_tag_field = lang+"_"+tag+"_htrctoken";
			    fields.push(lang_tag_field+":"+q_text);
			}
		    }
		}
	    }
	    
	    for (var li=0; li<langs_without_pos.length; li++) {
		var lang = langs_without_pos[li];
	    var lang_enabled_id = lang + "-enabled";
		var $lang_enabled_cb = $('#'+lang_enabled_id);
		
		if ($lang_enabled_cb.is(':checked')) {
		    console.log("Adding in non-POS field for: " + lang);
		    //var lang_tag_field = "xxxx"+lang+"_htrctoken";
		    var lang_tag_field = lang+"_htrctoken";
		    fields.push(lang_tag_field+":"+q_text);	    
		}
	    }
	
	    if (fields.length == 0) {
		alert("No languages selected");
		return;
	    }

	    if (qi>0) {
		arg_q += " OR ";
	    }
	    
	    arg_q += fields.join(" OR ");
    
	} // end of for each split q_text
	
	// Example search on one of the htrc-full-ef fields is: 
	//  q=en_NOUN_htrctoken:farming
	
	store_search_args = { q: arg_q, indent: arg_indent, wt: arg_wt, start: arg_start, rows: arg_rows };

	store_search_args.sort="id asc";
	store_search_args.fl="volumeid_s,id";
	
	var expr_tx = "search(htrc-full-ef20";
	
	for (var k in store_search_args) {
	    if (store_search_args.hasOwnProperty(k)) {
		var v = store_search_args[k];
		expr_tx += "," + k + "=\"" + v + "\"";
	    }
	}
	expr_tx += ")";
    }
    

    if ((expr_md != "") && (expr_tx != "")) {
	expr = "expr=intersect(" + expr_md + "," + expr_tx  + ", on=\"id=volumeid_s\")";
    }
    else if (expr_md != "") {
	expr = "expr=" + expr_md;
    }
    else if (expr_tx != "") {
	expr = "expr=" + expr_tx;
    }
    else {
	// both empty
	console.log("Warning: query was empty");
    }
    

    $.ajax({
	type: 'GET',
	url: store_search_action,
	data: expr,
	dataType: 'json',
	success: stream_show_results,
	error: ajax_error
    });

}

function submit_action(event)
{
    event.preventDefault();

    $('.search-in-progress').css("cursor","wait");
    
    store_search_action = $('#search-form').attr("action");
    
    var arg_indent = $('#indent').attr('value');
    var arg_wt     = $('#wt').attr('value');
    var arg_start  = $('#start').attr('value');
    var arg_rows   = $('#rows').attr('value');
    var q_text     = $('#q').val();

    group_by_vol_checked = $('#group-results-by-id:checked').length;

    
    if (q_text === "") {
	$('.search-in-progress').css("cursor","auto");
	alert("No query term entered");
	return;
    }
    
    var fields = [];
    //var langs_with_pos = [ "da", "de", "en", "nl", "pt", "se" ];
    var universal_pos_tags = [ "VERB", "NOUN", "ADJ", "ADV", "ADP", "CONJ", "DET", "NUM", "PRT", "X" ];
    
    for (var li=0; li<langs_with_pos.length; li++) {
	var lang = langs_with_pos[li];
	var lang_enabled_id = lang + "-enabled";
	var $lang_enabled_cb = $('#'+lang_enabled_id);
	if ($lang_enabled_cb.is(':checked')) {
	    console.log("Extracting POS tags for: " + lang);
	    
	    for (var ti=0; ti<universal_pos_tags.length; ti++) {
		var tag = universal_pos_tags[ti];
		var lang_tag_id = lang+"-"+tag+"-htrctoken-cb";
		var $lang_tag_cb = $('#'+lang_tag_id);
		if ($lang_tag_cb.is(':checked')) {
		    //var lang_tag_field = "xxxx"+lang+"_"+tag+"_htrctoken";
		    var lang_tag_field = lang+"_"+tag+"_htrctoken";
		    fields.push(lang_tag_field+":"+q_text);
		}
	    }
	}
    }

    for (var li=0; li<langs_without_pos.length; li++) {
	var lang = langs_without_pos[li];
	var lang_enabled_id = lang + "-enabled";
	var $lang_enabled_cb = $('#'+lang_enabled_id);

	if ($lang_enabled_cb.is(':checked')) {
	    console.log("Adding in non-POS field for: " + lang);
	    //var lang_tag_field = "xxxx"+lang+"_htrctoken";
	    var lang_tag_field = lang+"_htrctoken";
	    fields.push(lang_tag_field+":"+q_text);	    
	}
    }

    if (fields.length == 0) {
	alert("No languages selected");
	return;
    }
    
    var arg_q = fields.join(" OR ");
    
    
    // Example search on one of the htrc-full-ef fields is: 
    //  q=en_NOUN_htrctoken:farming
    
    store_search_args = { q: arg_q, indent: arg_indent, wt: arg_wt, start: arg_start, rows: arg_rows };

    if (group_by_vol_checked) {
	store_search_args.sort="id asc";
    }
    
    
    $.ajax({
	type: 'GET',
	url: store_search_action,
	data: store_search_args,
	dataType: 'json',
	success: show_results,
	error: ajax_error
    });

}

function generate_pos_langs()
{
    var pos_checkbox = [
	{ pos:"VERB", label:"Verbs",       tooltip:"Verbs (all tenses and modes)" },
	{ pos:"NOUN", label:"Nouns",       tooltip:"Nouns (common and proper)" },
	{ pos:"ADJ",  label:"Adjectives",  tooltip: null }, 
	{ pos:"ADV",  label:"Adverbs",     tooltip: null },
	{ pos:"ADP",  label:"Adpositions", tooltip:"Adpositions (prepositions and postpositions)" },
	{ pos:"CONJ", label:"Conjunctions",tooltip: null },
	{ pos:"DET",  label:"Determiners", tooltip: null },
	{ pos:"NUM",  label:"Numbers",     tooltip:"Cardinal numbers" },
	{ pos:"PRT",  label:"Particles",   tooltip:"Particles or other function words" },
	{ pos:"X",    label:"Other",       tooltip:"Other words, such as foreign words, typos, abbreviations"}
    ];

    var $pos_fieldsets = $('#pos-fieldsets');
    
    for (var li=0; li<langs_with_pos.length; li++) {

	var l = langs_with_pos[li];
	var lang_full = isoLangs[l].name;
	var lang_native_full = isoLangs[l].nativeName;
	var opt_title = (lang_full !== lang_native_full) ? 'title="'+lang_native_full+'"' : "";

	var opt_enabled = (l == "en") ? 'checked="checked"' : "";
	
	var legend = "";
	legend += '    <legend style="margin-bottom: 5px; padding-top: 15px;">\n';
	legend += '      <input type="checkbox" name="'+l+'-enabled" id="'+l+'-enabled" ' + opt_enabled +'/>\n';
	legend += '      <span ' + opt_title + '>'+lang_full+':</span>\n';
	legend += '    </legend>\n';
	

	var check_box_list = [];
	    
	for (var pi=0; pi<pos_checkbox.length; pi++) {
	    var pos_info = pos_checkbox[pi];
	    var pos = pos_info.pos;
	    var label = pos_info.label;
	    var tooltip = pos_info.tooltip;
	    var opt_tooltip = (tooltip != null) ? 'title="'+tooltip+'"' : "";
	    
	    var check_box = "";
	    check_box += '    <input type="checkbox" name="'+l+'-'+pos+'-htrctoken-cb" id="'+l+'-'+pos+'-htrctoken-cb" checked="checked" />\n';
	    check_box += '    <label for="'+l+'-'+pos+'-htrctoken-cb" '+opt_tooltip+'>'+label+'</label>\n';

	    check_box_list.push(check_box);
	}
	
	var fieldset = "";
	var opt_showhide_class = (li>0) ? 'class="show-hide-lang"' : "";

	if (li==1) {
	    fieldset += '<button id="show-hide-lang">Show other languages ...</button>';
	}
	
	fieldset += '<fieldset ' + opt_showhide_class + '>\n';
	fieldset += legend;
	fieldset += '  <div id="'+l+'-pos-choice">\n';

	var check_box_join = check_box_list.join('&nbsp;');
	fieldset += check_box_join;
	
	fieldset += '  </div>\n';
	fieldset += '</fieldset>\n';
	
	$pos_fieldsets.append(fieldset);
	$('#'+l+'-enabled').click(lang_pos_toggle);

	if (l == "en") {
	    $('#en-pos-choice *').prop('disabled',false);
	}
	else {
	    $('#'+l+'-pos-choice *').prop('disabled',true);
	}
    }


    //$('#en-enabled').click(lang_pos_toggle);
    //$('#de-enabled').click(lang_pos_toggle);
    //$('#de-pos-choice *').prop('disabled',true);

    show_hide_lang()
}

function show_hide_lang()
{
    $( "#show-hide-lang" ).click(function(event) {
	event.preventDefault(); 
	if($('.show-hide-lang:visible').length) {
	    $('.show-hide-lang').hide("slide", {direction: "up" } , 1000);
	    $('#show-hide-lang').html("Show other languages ...");
	}
	else {
	    $('.show-hide-lang').show("slide", {direction: "up" } , 1000);
	    $('#show-hide-lang').html("Hide other languages ...");
	}
    });
}

function generate_other_langs()
{
    // setup other languages
    // for each 'langs_without_pos' generate HTML of the form:
    //    <input type="checkbox" name="fr-enabled" id="fr-enabled" />French
    var $other_langs = $('#other-langs');

    for (var i=0; i<langs_without_pos.length; i++) {
	var lang = langs_without_pos[i];
	//var labeled_checkbox = '<span style="white-space:nowrap;">\n';
	var labeled_checkbox = '<nobr>';
	
	labeled_checkbox += '<input type="checkbox" name="'+lang+'-enabled" id="'+lang+'-enabled" />';
	/*
	if (lang === "zh-cn") {
	    console.log("Mapping zh-cn => zh");
	    lang = "zh";
	}
	if (lang === "zh-tw") {
	    console.log("Mapping zh-tw => zh");
	    lang = "zh";
	}
*/
	var lang_full = isoLangs[lang].name;
	var lang_native_full = isoLangs[lang].nativeName;
	var opt_title = (lang_full !== lang_native_full) ? 'title="'+lang_native_full+'"' : "";
	
	labeled_checkbox += '<label for="'+lang+'-enabled" style="padding-left: 5px; padding-right: 10px;" ' + opt_title + '>'+lang_full+'</label>';
	//labeled_checkbox += '</span>\n';
	labeled_checkbox += '</nobr> ';
	
	$other_langs.append(labeled_checkbox);
	
    }
}

$(function() {
    generate_pos_langs();

    generate_other_langs();

    if ($('#search-submit').length>0) {
	$('#search-submit').click(submit_action);
    }
    
    if ($('#stream-search-submit').length>0) {
	$('#stream-search-submit').click(stream_submit_action);
    }

});
